package flm.b4a.gesturedemo;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "flm.b4a.gesturedemo", "flm.b4a.gesturedemo.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "flm.b4a.gesturedemo", "flm.b4a.gesturedemo.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "flm.b4a.gesturedemo.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.MediaPlayerWrapper _collisionmp = null;
public static anywheresoftware.b4a.objects.MediaPlayerWrapper _movemp = null;
public static anywheresoftware.b4a.objects.MediaPlayerWrapper _winmp = null;
public static anywheresoftware.b4a.objects.Timer _wintimer = null;
public anywheresoftware.b4a.objects.PanelWrapper _levelpnl = null;
public anywheresoftware.b4a.objects.PanelWrapper _wormpnl = null;
public flm.b4a.gesturedemo.main._typepoints[] _points = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvworm = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvlevel = null;
public static int _level = 0;
public anywheresoftware.b4a.objects.collections.List _dotlist = null;
public static boolean _redwormmove = false;
public static boolean _bluewormmove = false;
public static int _wormnrdown = 0;
public static boolean _levelfinished = false;
public static float _lastx = 0f;
public static int _exitworm = 0;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static class _typepoints{
public boolean IsInitialized;
public float x;
public float y;
public String worm;
public String head;
public int nr;
public void Initialize() {
IsInitialized = true;
x = 0f;
y = 0f;
worm = "";
head = "";
nr = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 40;BA.debugLine="wintimer.Initialize(\"wintimer\",400)";
_wintimer.Initialize(processBA,"wintimer",(long) (400));
 //BA.debugLineNum = 43;BA.debugLine="levelpnl.Initialize(\"\")";
mostCurrent._levelpnl.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 44;BA.debugLine="levelpnl.Color = Colors.LightGray";
mostCurrent._levelpnl.setColor(anywheresoftware.b4a.keywords.Common.Colors.LightGray);
 //BA.debugLineNum = 45;BA.debugLine="Activity.AddView(levelpnl,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._levelpnl.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 48;BA.debugLine="wormpnl.Initialize(\"wormpnl\")";
mostCurrent._wormpnl.Initialize(mostCurrent.activityBA,"wormpnl");
 //BA.debugLineNum = 49;BA.debugLine="wormpnl.Color = Colors.Transparent";
mostCurrent._wormpnl.setColor(anywheresoftware.b4a.keywords.Common.Colors.Transparent);
 //BA.debugLineNum = 50;BA.debugLine="Activity.AddView(wormpnl,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._wormpnl.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 52;BA.debugLine="collisionmp.Initialize";
_collisionmp.Initialize();
 //BA.debugLineNum = 53;BA.debugLine="collisionmp.Load(File.DirAssets,\"syoop.mp3\")";
_collisionmp.Load(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"syoop.mp3");
 //BA.debugLineNum = 55;BA.debugLine="movemp.Initialize";
_movemp.Initialize();
 //BA.debugLineNum = 56;BA.debugLine="movemp.Load(File.DirAssets,\"click.mp3\")";
_movemp.Load(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"click.mp3");
 //BA.debugLineNum = 58;BA.debugLine="winmp.Initialize";
_winmp.Initialize();
 //BA.debugLineNum = 59;BA.debugLine="winmp.Load(File.DirAssets,\"win.mp3\")";
_winmp.Load(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"win.mp3");
 //BA.debugLineNum = 61;BA.debugLine="level = 1 'first level";
_level = (int) (1);
 //BA.debugLineNum = 64;BA.debugLine="cvlevel.Initialize(levelpnl)";
mostCurrent._cvlevel.Initialize((android.view.View)(mostCurrent._levelpnl.getObject()));
 //BA.debugLineNum = 65;BA.debugLine="cvworm.Initialize(wormpnl)";
mostCurrent._cvworm.Initialize((android.view.View)(mostCurrent._wormpnl.getObject()));
 //BA.debugLineNum = 67;BA.debugLine="dotlist.Initialize";
mostCurrent._dotlist.Initialize();
 //BA.debugLineNum = 69;BA.debugLine="levelfinished = False 'didnot solve the puzzle ye";
_levelfinished = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 71;BA.debugLine="startdrawinglevel1 'draw level1 & add all dots to";
_startdrawinglevel1();
 //BA.debugLineNum = 72;BA.debugLine="setlevel 'set the location of worms depends on le";
_setlevel();
 //BA.debugLineNum = 73;BA.debugLine="redrawworms 'draw worms";
_redrawworms();
 //BA.debugLineNum = 75;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 80;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 77;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
public static String  _checkifsharpturn(int _finishpnt,int _wormhead) throws Exception{
String[] _str = null;
 //BA.debugLineNum = 380;BA.debugLine="Sub checkifsharpturn(finishpnt As Int, wormhead As";
 //BA.debugLineNum = 382;BA.debugLine="Select level";
switch (_level) {
case 1:
 //BA.debugLineNum = 385;BA.debugLine="If finishpnt - wormhead = 7 Then";
if (_finishpnt-_wormhead==7) { 
 //BA.debugLineNum = 386;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_wormhead+1))));
 //BA.debugLineNum = 387;BA.debugLine="If str(2) <> \"r\" Then";
if ((_str[(int) (2)]).equals("r") == false) { 
 //BA.debugLineNum = 388;BA.debugLine="levelfinished = True";
_levelfinished = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 389;BA.debugLine="wintimer.Enabled = True";
_wintimer.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 };
 //BA.debugLineNum = 392;BA.debugLine="Log(\"xxx\")";
anywheresoftware.b4a.keywords.Common.Log("xxx");
 break;
case 2:
 break;
}
;
 //BA.debugLineNum = 398;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Dim levelpnl As Panel";
mostCurrent._levelpnl = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Dim wormpnl As Panel";
mostCurrent._wormpnl = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Type typepoints(x As Float, y As Float, worm As S";
;
 //BA.debugLineNum = 26;BA.debugLine="Dim points(15) As typepoints";
mostCurrent._points = new flm.b4a.gesturedemo.main._typepoints[(int) (15)];
{
int d0 = mostCurrent._points.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._points[i0] = new flm.b4a.gesturedemo.main._typepoints();
}
}
;
 //BA.debugLineNum = 27;BA.debugLine="Dim cvworm As Canvas";
mostCurrent._cvworm = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim cvlevel As Canvas";
mostCurrent._cvlevel = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim level As Int 'level selection";
_level = 0;
 //BA.debugLineNum = 30;BA.debugLine="Dim dotlist As List";
mostCurrent._dotlist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 31;BA.debugLine="Dim redwormmove, bluewormmove As Boolean = False";
_redwormmove = false;
_bluewormmove = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 32;BA.debugLine="Dim wormnrdown As Int";
_wormnrdown = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim levelfinished As Boolean";
_levelfinished = false;
 //BA.debugLineNum = 34;BA.debugLine="Dim lastx As Float";
_lastx = 0f;
 //BA.debugLineNum = 35;BA.debugLine="Dim exitworm As Int";
_exitworm = 0;
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 15;BA.debugLine="Dim collisionmp As MediaPlayer";
_collisionmp = new anywheresoftware.b4a.objects.MediaPlayerWrapper();
 //BA.debugLineNum = 16;BA.debugLine="Dim movemp As MediaPlayer";
_movemp = new anywheresoftware.b4a.objects.MediaPlayerWrapper();
 //BA.debugLineNum = 17;BA.debugLine="Dim winmp As MediaPlayer";
_winmp = new anywheresoftware.b4a.objects.MediaPlayerWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Dim wintimer As Timer";
_wintimer = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _redrawworms() throws Exception{
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rect1 = null;
anywheresoftware.b4a.objects.collections.List _bodylist = null;
int _maxwormred = 0;
int _maxwormblue = 0;
int _i = 0;
String[] _str = null;
String[] _str2 = null;
 //BA.debugLineNum = 210;BA.debugLine="Sub redrawworms";
 //BA.debugLineNum = 212;BA.debugLine="Select level";
switch (_level) {
case 1:
 //BA.debugLineNum = 216;BA.debugLine="Dim rect1 As Rect 'clear board";
_rect1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 217;BA.debugLine="rect1.Initialize(wormpnl.Left,wormpnl.top,wormpn";
_rect1.Initialize(mostCurrent._wormpnl.getLeft(),mostCurrent._wormpnl.getTop(),mostCurrent._wormpnl.getWidth(),mostCurrent._wormpnl.getHeight());
 //BA.debugLineNum = 218;BA.debugLine="cvworm.DrawRect(rect1,Colors.Transparent,True,0)";
mostCurrent._cvworm.DrawRect((android.graphics.Rect)(_rect1.getObject()),anywheresoftware.b4a.keywords.Common.Colors.Transparent,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 220;BA.debugLine="Dim bodyList As List";
_bodylist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 221;BA.debugLine="bodyList.Initialize";
_bodylist.Initialize();
 //BA.debugLineNum = 222;BA.debugLine="bodyList.Clear";
_bodylist.Clear();
 //BA.debugLineNum = 224;BA.debugLine="Dim maxwormred As Int = exitworm 'set worm lengt";
_maxwormred = _exitworm;
 //BA.debugLineNum = 225;BA.debugLine="Dim maxwormblue As Int = 3 'set worm length blue";
_maxwormblue = (int) (3);
 //BA.debugLineNum = 228;BA.debugLine="For i = 0 To dotlist.Size - 1";
{
final int step155 = 1;
final int limit155 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step155 > 0 && _i <= limit155) || (step155 < 0 && _i >= limit155); _i = ((int)(0 + _i + step155))) {
 //BA.debugLineNum = 229;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 230;BA.debugLine="If str(2) = \"r\" Then";
if ((_str[(int) (2)]).equals("r")) { 
 //BA.debugLineNum = 231;BA.debugLine="bodyList.Add(dotlist.Get(i))";
_bodylist.Add(mostCurrent._dotlist.Get(_i));
 }else if((_str[(int) (2)]).equals("b")) { 
 //BA.debugLineNum = 233;BA.debugLine="bodyList.Add(dotlist.Get(i))";
_bodylist.Add(mostCurrent._dotlist.Get(_i));
 };
 }
};
 //BA.debugLineNum = 238;BA.debugLine="For i = 0 To bodyList.Size -2";
{
final int step163 = 1;
final int limit163 = (int) (_bodylist.getSize()-2);
for (_i = (int) (0); (step163 > 0 && _i <= limit163) || (step163 < 0 && _i >= limit163); _i = ((int)(0 + _i + step163))) {
 //BA.debugLineNum = 239;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",bodyList";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(_bodylist.Get(_i)));
 //BA.debugLineNum = 240;BA.debugLine="Dim str2() As String = Regex.Split(\"\\|\",bodyLis";
_str2 = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(_bodylist.Get((int) (_i+1))));
 //BA.debugLineNum = 242;BA.debugLine="If str(2) = \"r\" Then";
if ((_str[(int) (2)]).equals("r")) { 
 //BA.debugLineNum = 243;BA.debugLine="If maxwormred > 1 Then cvworm.DrawLine(str(0),";
if (_maxwormred>1) { 
mostCurrent._cvworm.DrawLine((float)(Double.parseDouble(_str[(int) (0)])),(float)(Double.parseDouble(_str[(int) (1)])),(float)(Double.parseDouble(_str2[(int) (0)])),(float)(Double.parseDouble(_str2[(int) (1)])),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (231),(int) (76),(int) (60)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)));};
 //BA.debugLineNum = 244;BA.debugLine="maxwormred = maxwormred-1";
_maxwormred = (int) (_maxwormred-1);
 }else if((_str[(int) (2)]).equals("b")) { 
 //BA.debugLineNum = 246;BA.debugLine="If maxwormblue > 1 Then cvworm.DrawLine(str(0)";
if (_maxwormblue>1) { 
mostCurrent._cvworm.DrawLine((float)(Double.parseDouble(_str[(int) (0)])),(float)(Double.parseDouble(_str[(int) (1)])),(float)(Double.parseDouble(_str2[(int) (0)])),(float)(Double.parseDouble(_str2[(int) (1)])),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (152),(int) (219)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)));};
 //BA.debugLineNum = 247;BA.debugLine="maxwormblue = maxwormblue-1";
_maxwormblue = (int) (_maxwormblue-1);
 };
 }
};
 //BA.debugLineNum = 252;BA.debugLine="For i = 0 To dotlist.Size - 1";
{
final int step174 = 1;
final int limit174 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step174 > 0 && _i <= limit174) || (step174 < 0 && _i >= limit174); _i = ((int)(0 + _i + step174))) {
 //BA.debugLineNum = 253;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 254;BA.debugLine="If str(2) = \"r\" Then";
if ((_str[(int) (2)]).equals("r")) { 
 //BA.debugLineNum = 255;BA.debugLine="cvworm.DrawCircle(str(0),str(1),5.2%y,Colors.R";
mostCurrent._cvworm.DrawCircle((float)(Double.parseDouble(_str[(int) (0)])),(float)(Double.parseDouble(_str[(int) (1)])),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5.2),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (231),(int) (76),(int) (60)),anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 256;BA.debugLine="cvworm.DrawCircle(str(0),str(1),3.9%y,Colors.W";
mostCurrent._cvworm.DrawCircle((float)(Double.parseDouble(_str[(int) (0)])),(float)(Double.parseDouble(_str[(int) (1)])),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (3.9),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.False,(float) (0));
 }else if((_str[(int) (2)]).equals("b")) { 
 //BA.debugLineNum = 258;BA.debugLine="cvworm.DrawCircle(str(0),str(1),5.2%y,Colors.R";
mostCurrent._cvworm.DrawCircle((float)(Double.parseDouble(_str[(int) (0)])),(float)(Double.parseDouble(_str[(int) (1)])),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (5.2),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (152),(int) (219)),anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 259;BA.debugLine="cvworm.DrawCircle(str(0),str(1),3.9%y,Colors.W";
mostCurrent._cvworm.DrawCircle((float)(Double.parseDouble(_str[(int) (0)])),(float)(Double.parseDouble(_str[(int) (1)])),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (3.9),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.False,(float) (0));
 };
 }
};
 //BA.debugLineNum = 263;BA.debugLine="Activity.Invalidate";
mostCurrent._activity.Invalidate();
 break;
case 2:
 break;
}
;
 //BA.debugLineNum = 271;BA.debugLine="End Sub";
return "";
}
public static String  _setlevel() throws Exception{
int _i = 0;
String[] _str = null;
 //BA.debugLineNum = 170;BA.debugLine="Sub setlevel";
 //BA.debugLineNum = 172;BA.debugLine="Select level";
switch (_level) {
case 1:
 //BA.debugLineNum = 175;BA.debugLine="dotlist.Clear";
mostCurrent._dotlist.Clear();
 //BA.debugLineNum = 176;BA.debugLine="dotlist.Add(19.25%x & \"|\" & 35.15%y & \"|e|e\") '";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (19.25),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 177;BA.debugLine="dotlist.Add(27.6%x & \"|\" & 35.15%y & \"|e|e\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 178;BA.debugLine="dotlist.Add(33.5%x & \"|\" & 24.75%y & \"|e|e\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 179;BA.debugLine="dotlist.Add(41.8%x & \"|\" & 24.75%y & \"|e|e\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 180;BA.debugLine="dotlist.Add(50%x & \"|\" & 24.75%y & \"|e|e\") 'r =";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 181;BA.debugLine="dotlist.Add(57.7%x & \"|\" & 35.15%y & \"|b|h\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (57.7),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA))+"|b|h"));
 //BA.debugLineNum = 182;BA.debugLine="dotlist.Add(65.2%x & \"|\" & 45.7%y & \"|b|b\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (45.7),mostCurrent.activityBA))+"|b|b"));
 //BA.debugLineNum = 183;BA.debugLine="dotlist.Add(72.75%x & \"|\" & 56%y & \"|b|h\") 'r =";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA))+"|b|h"));
 //BA.debugLineNum = 184;BA.debugLine="dotlist.Add(65.2%x & \"|\" & 66.4%y & \"|e|e\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 185;BA.debugLine="dotlist.Add(56.85%x & \"|\" & 66.4%y  & \"|e|e\") '";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA))+"|e|e"));
 //BA.debugLineNum = 186;BA.debugLine="dotlist.Add(50%x & \"|\" & 76.8%y & \"|r|h\") 'r =";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA))+"|r|h"));
 //BA.debugLineNum = 187;BA.debugLine="dotlist.Add(41.8%x & \"|\" & 76.8%y & \"|r|b\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA))+"|r|b"));
 //BA.debugLineNum = 188;BA.debugLine="dotlist.Add(35.1%x & \"|\" & 66.4%y & \"|r|b\") 'r";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (35.1),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA))+"|r|b"));
 //BA.debugLineNum = 189;BA.debugLine="dotlist.Add(28.4%x & \"|\" & 56%y & \"|r|h\") 'r =";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (28.4),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA))+"|r|h"));
 //BA.debugLineNum = 190;BA.debugLine="dotlist.Add(80.25%x & \"|\" & 66.4%y & \"|f|f\") 'f";
mostCurrent._dotlist.Add((Object)(BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80.25),mostCurrent.activityBA))+"|"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA))+"|f|f"));
 //BA.debugLineNum = 193;BA.debugLine="For i = 0 To dotlist.Size-1";
{
final int step132 = 1;
final int limit132 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step132 > 0 && _i <= limit132) || (step132 < 0 && _i >= limit132); _i = ((int)(0 + _i + step132))) {
 //BA.debugLineNum = 194;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 195;BA.debugLine="points(i).x = str(0)";
mostCurrent._points[_i].x = (float)(Double.parseDouble(_str[(int) (0)]));
 //BA.debugLineNum = 196;BA.debugLine="points(i).y = str(1)";
mostCurrent._points[_i].y = (float)(Double.parseDouble(_str[(int) (1)]));
 //BA.debugLineNum = 197;BA.debugLine="points(i).worm = str(2)";
mostCurrent._points[_i].worm = _str[(int) (2)];
 //BA.debugLineNum = 198;BA.debugLine="points(i).head = str(3)";
mostCurrent._points[_i].head = _str[(int) (3)];
 //BA.debugLineNum = 199;BA.debugLine="points(i).nr = (i)";
mostCurrent._points[_i].nr = (_i);
 }
};
 //BA.debugLineNum = 203;BA.debugLine="exitworm = 4 'in level 1 the length of the red";
_exitworm = (int) (4);
 break;
case 2:
 break;
}
;
 //BA.debugLineNum = 208;BA.debugLine="End Sub";
return "";
}
public static String  _startdrawinglevel1() throws Exception{
 //BA.debugLineNum = 85;BA.debugLine="Sub startdrawinglevel1";
 //BA.debugLineNum = 88;BA.debugLine="cvlevel.DrawText(\"NO SHARP\",80%x,9%y,Typeface.DE";
mostCurrent._cvlevel.DrawText(mostCurrent.activityBA,"NO SHARP",(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (9),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,(float) (16),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (192),(int) (57),(int) (43)),BA.getEnumFromString(android.graphics.Paint.Align.class,"CENTER"));
 //BA.debugLineNum = 89;BA.debugLine="cvlevel.DrawText(\"TURNS\",80%x,14%y,Typeface.DEFA";
mostCurrent._cvlevel.DrawText(mostCurrent.activityBA,"TURNS",(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (14),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,(float) (16),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (192),(int) (57),(int) (43)),BA.getEnumFromString(android.graphics.Paint.Align.class,"CENTER"));
 //BA.debugLineNum = 90;BA.debugLine="cvlevel.DrawText(\"X\",87%x,31.25%y,Typeface.DEFAU";
mostCurrent._cvlevel.DrawText(mostCurrent.activityBA,"X",(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (87),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (31.25),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,(float) (16),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (192),(int) (57),(int) (43)),BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 91;BA.debugLine="cvlevel.DrawText(\"V\",87%x,24.75%y,Typeface.DEFAU";
mostCurrent._cvlevel.DrawText(mostCurrent.activityBA,"V",(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (87),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,(float) (16),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (152),(int) (219)),BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 92;BA.debugLine="cvlevel.DrawLine(80%x,20%y,85%x,36.5%y,Colors.RG";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (36.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (73),(int) (94)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (3.9),mostCurrent.activityBA)));
 //BA.debugLineNum = 93;BA.debugLine="cvlevel.DrawLine(82.8%x,28.65%y,80%x,36.5%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (82.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (28.65),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (36.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (73),(int) (94)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (3.9),mostCurrent.activityBA)));
 //BA.debugLineNum = 94;BA.debugLine="cvlevel.DrawLine(82.8%x,28.65%y,80%x,36.5%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (82.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (28.65),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (36.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (152),(int) (219)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (1.55),mostCurrent.activityBA)));
 //BA.debugLineNum = 95;BA.debugLine="cvlevel.DrawLine(80%x,20%y,85%x,36.5%y,Colors.RG";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (36.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (152),(int) (219)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)));
 //BA.debugLineNum = 96;BA.debugLine="cvlevel.DrawLine(82.8%x,28.65%y,80%x,36.5%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (82.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (28.65),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (36.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (231),(int) (76),(int) (60)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)));
 //BA.debugLineNum = 97;BA.debugLine="cvlevel.DrawLine(82.8%x,28.65%y,85%x,36.5%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (82.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (28.65),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (36.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (231),(int) (76),(int) (60)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)));
 //BA.debugLineNum = 99;BA.debugLine="Select level";
switch (_level) {
case 1:
 //BA.debugLineNum = 103;BA.debugLine="cvlevel.DrawText(\"LEVEL 1\",5%x,9%y,Typeface.DEFA";
mostCurrent._cvlevel.DrawText(mostCurrent.activityBA,"LEVEL 1",(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (9),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT_BOLD,(float) (18),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (52),(int) (73),(int) (94)),BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 106;BA.debugLine="cvlevel.DrawCircle(33.5%x,24.75%y,6.5%y,Colors.W";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 107;BA.debugLine="cvlevel.DrawCircle(50%x,24.75%y,6.5%y,Colors.Whi";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 108;BA.debugLine="cvlevel.DrawCircle(27.6%x,35.15%y,6.5%y,Colors.W";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 109;BA.debugLine="cvlevel.DrawCircle(19.25%x,35.15%y,6.5%y,Colors.";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (19.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 110;BA.debugLine="cvlevel.DrawCircle(65.2%x,66.4%y,6.5%y,Colors.Wh";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 111;BA.debugLine="cvlevel.DrawCircle(56.85%x,66.4%y,6.5%y,Colors.W";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 112;BA.debugLine="cvlevel.DrawCircle(50%x,76.8%y,6.5%y,Colors.Whit";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 113;BA.debugLine="cvlevel.DrawCircle(41.8%x,76.8%y,6.5%y,Colors.Wh";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 114;BA.debugLine="cvlevel.DrawCircle(35.1%x,66.4%y,6.5%y,Colors.Wh";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (35.1),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 115;BA.debugLine="cvlevel.DrawCircle(28.4%x,56%y,6.5%y,Colors.Whit";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (28.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 116;BA.debugLine="cvlevel.DrawLine(33.5%x,24.75%y,50%x,24.75%y,Col";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 117;BA.debugLine="cvlevel.DrawLine(19.25%x,35.15%y,27.6%x,35.15%y,";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (19.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 118;BA.debugLine="cvlevel.DrawLine(27.6%x,35.15%y,33.5%x,24.75%y,C";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 119;BA.debugLine="cvlevel.DrawCircle(80.25%x,66.4%y,6.5%y,Colors.R";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (231),(int) (76),(int) (60)),anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 120;BA.debugLine="cvlevel.DrawLine(72.75%x,56%y,80.25%x,66.4%y,Col";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.RGB((int) (231),(int) (76),(int) (60)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 121;BA.debugLine="cvlevel.DrawCircle(72.75%x,56%y,6.5%y,Colors.Whi";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6.5),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 122;BA.debugLine="cvlevel.DrawLine(50%x,24.75%y,72.75%x,56%y,Color";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 123;BA.debugLine="cvlevel.DrawLine(28.4%x,56%y,41.8%x,76.8%y,Color";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (28.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 124;BA.debugLine="cvlevel.DrawLine(41.8%x,76.8%y,50%x,76.8%y,Color";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 125;BA.debugLine="cvlevel.DrawLine(50%x,76.8%y,56.85%x,66.4%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 126;BA.debugLine="cvlevel.DrawLine(56.85%x,66.4%y,65.2%x,66.4%y,Co";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 127;BA.debugLine="cvlevel.DrawLine(65.2%x,66.4%y,72.75%x,56%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (13),mostCurrent.activityBA)));
 //BA.debugLineNum = 130;BA.debugLine="cvlevel.DrawLine(19.25%x,35.15%y,27.6%x,35.15%y,";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (19.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 131;BA.debugLine="cvlevel.DrawLine(27.6%x,35.15%y,33.5%x,24.75%y,C";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 132;BA.debugLine="cvlevel.DrawLine(33.5%x,24.75%y,50%x,24.75%y,Col";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 133;BA.debugLine="cvlevel.DrawLine(50%x,24.75%y,72.75%x,56%y,Color";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 134;BA.debugLine="cvlevel.DrawLine(28.4%x,56%y,41.8%x,76.8%y,Color";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (28.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 135;BA.debugLine="cvlevel.DrawLine(41.8%x,76.8%y,50%x,76.8%y,Color";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 136;BA.debugLine="cvlevel.DrawLine(50%x,76.8%y,56.85%x,66.4%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 137;BA.debugLine="cvlevel.DrawLine(56.85%x,66.4%y,65.2%x,66.4%y,Co";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 138;BA.debugLine="cvlevel.DrawLine(65.2%x,66.4%y,72.75%x,56%y,Colo";
mostCurrent._cvlevel.DrawLine((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.LightGray,(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.5),mostCurrent.activityBA)));
 //BA.debugLineNum = 141;BA.debugLine="cvlevel.DrawCircle(19.25%x,35.15%y,0.8%y,Colors.";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (19.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 142;BA.debugLine="cvlevel.DrawCircle(27.6%x,35.15%y,0.8%y,Colors.G";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (27.6),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 143;BA.debugLine="cvlevel.DrawCircle(33.5%x,24.75%y,0.8%y,Colors.G";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (33.5),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 144;BA.debugLine="cvlevel.DrawCircle(41.8%x,24.75%y,0.8%y,Colors.G";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 145;BA.debugLine="cvlevel.DrawCircle(50%x,24.75%y,0.8%y,Colors.Gra";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 146;BA.debugLine="cvlevel.DrawCircle(57.7%x,35.15%y,0.8%y,Colors.G";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (57.7),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (35.15),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 147;BA.debugLine="cvlevel.DrawCircle(65.2%x,45.7%y,0.8%y,Colors.Gr";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (45.7),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 148;BA.debugLine="cvlevel.DrawCircle(72.75%x,56%y,0.8%y,Colors.Gra";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (72.75),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 149;BA.debugLine="cvlevel.DrawCircle(65.2%x,66.4%y,0.8%y,Colors.Gr";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (65.2),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 150;BA.debugLine="cvlevel.DrawCircle(56.85%x,66.4%y,0.8%y,Colors.G";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (56.85),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 151;BA.debugLine="cvlevel.DrawCircle(50%x,76.8%y,0.8%y,Colors.Gray";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 152;BA.debugLine="cvlevel.DrawCircle(41.8%x,76.8%y,0.8%y,Colors.Gr";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (41.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (76.8),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 153;BA.debugLine="cvlevel.DrawCircle(35.1%x,66.4%y,0.8%y,Colors.Gr";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (35.1),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 154;BA.debugLine="cvlevel.DrawCircle(28.4%x,56%y,0.8%y,Colors.Gray";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (28.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (56),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.Gray,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 155;BA.debugLine="cvlevel.DrawCircle(80.25%x,66.4%y,0.8%y,Colors.W";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0.8),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.True,(float) (0));
 //BA.debugLineNum = 156;BA.debugLine="cvlevel.DrawCircle(80.25%x,66.4%y,3.1%y,Colors.W";
mostCurrent._cvlevel.DrawCircle((float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (80.25),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (66.4),mostCurrent.activityBA)),(float) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (3.1),mostCurrent.activityBA)),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.False,(float) (2));
 //BA.debugLineNum = 158;BA.debugLine="Activity.Invalidate";
mostCurrent._activity.Invalidate();
 break;
case 2:
 break;
}
;
 //BA.debugLineNum = 165;BA.debugLine="End Sub";
return "";
}
public static String  _updatepoints(int _newpoint,String _wormstr,int _oldpoint) throws Exception{
String[] _str = null;
int _i = 0;
 //BA.debugLineNum = 273;BA.debugLine="Sub updatepoints(newpoint As Int, wormstr As Strin";
 //BA.debugLineNum = 275;BA.debugLine="If wormstr = \"r\" Then 'red worm";
if ((_wormstr).equals("r")) { 
 //BA.debugLineNum = 277;BA.debugLine="If newpoint < oldpoint Then 'if nr is smaller the";
if (_newpoint<_oldpoint) { 
 //BA.debugLineNum = 279;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_newpoint)));
 //BA.debugLineNum = 280;BA.debugLine="dotlist.Set(newpoint,str(0) & \"|\" & str(1) & \"|\"";
mostCurrent._dotlist.Set(_newpoint,(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|h"));
 //BA.debugLineNum = 282;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+1))));
 //BA.debugLineNum = 283;BA.debugLine="dotlist.Set(newpoint+1,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+1),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|b"));
 //BA.debugLineNum = 285;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+2))));
 //BA.debugLineNum = 286;BA.debugLine="dotlist.Set(newpoint+2,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+2),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|b"));
 //BA.debugLineNum = 288;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+3))));
 //BA.debugLineNum = 289;BA.debugLine="dotlist.Set(newpoint+3,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+3),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|h"));
 //BA.debugLineNum = 291;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+4))));
 //BA.debugLineNum = 292;BA.debugLine="dotlist.Set(newpoint+4,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+4),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"e|e"));
 //BA.debugLineNum = 295;BA.debugLine="For i = 0 To dotlist.Size-1";
{
final int step201 = 1;
final int limit201 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step201 > 0 && _i <= limit201) || (step201 < 0 && _i >= limit201); _i = ((int)(0 + _i + step201))) {
 //BA.debugLineNum = 296;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 297;BA.debugLine="points(i).x = str(0)";
mostCurrent._points[_i].x = (float)(Double.parseDouble(_str[(int) (0)]));
 //BA.debugLineNum = 298;BA.debugLine="points(i).y = str(1)";
mostCurrent._points[_i].y = (float)(Double.parseDouble(_str[(int) (1)]));
 //BA.debugLineNum = 299;BA.debugLine="points(i).worm = str(2)";
mostCurrent._points[_i].worm = _str[(int) (2)];
 //BA.debugLineNum = 300;BA.debugLine="points(i).head = str(3)";
mostCurrent._points[_i].head = _str[(int) (3)];
 //BA.debugLineNum = 301;BA.debugLine="points(i).nr = (i)";
mostCurrent._points[_i].nr = (_i);
 }
};
 }else if(_newpoint>_oldpoint) { 
 //BA.debugLineNum = 306;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_newpoint)));
 //BA.debugLineNum = 307;BA.debugLine="dotlist.Set(newpoint,str(0) & \"|\" & str(1) & \"|\"";
mostCurrent._dotlist.Set(_newpoint,(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|h"));
 //BA.debugLineNum = 308;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-1))));
 //BA.debugLineNum = 309;BA.debugLine="dotlist.Set(newpoint-1,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-1),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|b"));
 //BA.debugLineNum = 310;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-2))));
 //BA.debugLineNum = 311;BA.debugLine="dotlist.Set(newpoint-2,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-2),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|b"));
 //BA.debugLineNum = 312;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-3))));
 //BA.debugLineNum = 313;BA.debugLine="dotlist.Set(newpoint-3,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-3),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"r|h"));
 //BA.debugLineNum = 314;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-4))));
 //BA.debugLineNum = 315;BA.debugLine="dotlist.Set(newpoint-4,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-4),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"e|e"));
 //BA.debugLineNum = 318;BA.debugLine="For i = 0 To dotlist.Size-1";
{
final int step220 = 1;
final int limit220 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step220 > 0 && _i <= limit220) || (step220 < 0 && _i >= limit220); _i = ((int)(0 + _i + step220))) {
 //BA.debugLineNum = 319;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 320;BA.debugLine="points(i).x = str(0)";
mostCurrent._points[_i].x = (float)(Double.parseDouble(_str[(int) (0)]));
 //BA.debugLineNum = 321;BA.debugLine="points(i).y = str(1)";
mostCurrent._points[_i].y = (float)(Double.parseDouble(_str[(int) (1)]));
 //BA.debugLineNum = 322;BA.debugLine="points(i).worm = str(2)";
mostCurrent._points[_i].worm = _str[(int) (2)];
 //BA.debugLineNum = 323;BA.debugLine="points(i).head = str(3)";
mostCurrent._points[_i].head = _str[(int) (3)];
 //BA.debugLineNum = 324;BA.debugLine="points(i).nr = (i)";
mostCurrent._points[_i].nr = (_i);
 }
};
 };
 }else if((_wormstr).equals("b")) { 
 //BA.debugLineNum = 331;BA.debugLine="If newpoint < oldpoint Then 'if nr is smaller the";
if (_newpoint<_oldpoint) { 
 //BA.debugLineNum = 333;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_newpoint)));
 //BA.debugLineNum = 334;BA.debugLine="dotlist.Set(newpoint,str(0) & \"|\" & str(1) & \"|\"";
mostCurrent._dotlist.Set(_newpoint,(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"b|h"));
 //BA.debugLineNum = 335;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+1))));
 //BA.debugLineNum = 336;BA.debugLine="dotlist.Set(newpoint+1,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+1),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"b|b"));
 //BA.debugLineNum = 337;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+2))));
 //BA.debugLineNum = 338;BA.debugLine="dotlist.Set(newpoint+2,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+2),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"b|h"));
 //BA.debugLineNum = 339;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint+3))));
 //BA.debugLineNum = 340;BA.debugLine="dotlist.Set(newpoint+3,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint+3),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"e|e"));
 //BA.debugLineNum = 343;BA.debugLine="For i = 0 To dotlist.Size-1";
{
final int step239 = 1;
final int limit239 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step239 > 0 && _i <= limit239) || (step239 < 0 && _i >= limit239); _i = ((int)(0 + _i + step239))) {
 //BA.debugLineNum = 344;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 345;BA.debugLine="points(i).x = str(0)";
mostCurrent._points[_i].x = (float)(Double.parseDouble(_str[(int) (0)]));
 //BA.debugLineNum = 346;BA.debugLine="points(i).y = str(1)";
mostCurrent._points[_i].y = (float)(Double.parseDouble(_str[(int) (1)]));
 //BA.debugLineNum = 347;BA.debugLine="points(i).worm = str(2)";
mostCurrent._points[_i].worm = _str[(int) (2)];
 //BA.debugLineNum = 348;BA.debugLine="points(i).head = str(3)";
mostCurrent._points[_i].head = _str[(int) (3)];
 //BA.debugLineNum = 349;BA.debugLine="points(i).nr = (i)";
mostCurrent._points[_i].nr = (_i);
 }
};
 }else if(_newpoint>_oldpoint) { 
 //BA.debugLineNum = 354;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_newpoint)));
 //BA.debugLineNum = 355;BA.debugLine="dotlist.Set(newpoint,str(0) & \"|\" & str(1) & \"|\"";
mostCurrent._dotlist.Set(_newpoint,(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"b|h"));
 //BA.debugLineNum = 356;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-1))));
 //BA.debugLineNum = 357;BA.debugLine="dotlist.Set(newpoint-1,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-1),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"b|b"));
 //BA.debugLineNum = 358;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-2))));
 //BA.debugLineNum = 359;BA.debugLine="dotlist.Set(newpoint-2,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-2),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"b|h"));
 //BA.debugLineNum = 360;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.G";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get((int) (_newpoint-3))));
 //BA.debugLineNum = 361;BA.debugLine="dotlist.Set(newpoint-3,str(0) & \"|\" & str(1) & \"";
mostCurrent._dotlist.Set((int) (_newpoint-3),(Object)(_str[(int) (0)]+"|"+_str[(int) (1)]+"|"+"e|e"));
 //BA.debugLineNum = 364;BA.debugLine="For i = 0 To dotlist.Size-1";
{
final int step256 = 1;
final int limit256 = (int) (mostCurrent._dotlist.getSize()-1);
for (_i = (int) (0); (step256 > 0 && _i <= limit256) || (step256 < 0 && _i >= limit256); _i = ((int)(0 + _i + step256))) {
 //BA.debugLineNum = 365;BA.debugLine="Dim str() As String = Regex.Split(\"\\|\",dotlist.";
_str = anywheresoftware.b4a.keywords.Common.Regex.Split("\\|",BA.ObjectToString(mostCurrent._dotlist.Get(_i)));
 //BA.debugLineNum = 366;BA.debugLine="points(i).x = str(0)";
mostCurrent._points[_i].x = (float)(Double.parseDouble(_str[(int) (0)]));
 //BA.debugLineNum = 367;BA.debugLine="points(i).y = str(1)";
mostCurrent._points[_i].y = (float)(Double.parseDouble(_str[(int) (1)]));
 //BA.debugLineNum = 368;BA.debugLine="points(i).worm = str(2)";
mostCurrent._points[_i].worm = _str[(int) (2)];
 //BA.debugLineNum = 369;BA.debugLine="points(i).head = str(3)";
mostCurrent._points[_i].head = _str[(int) (3)];
 //BA.debugLineNum = 370;BA.debugLine="points(i).nr = (i)";
mostCurrent._points[_i].nr = (_i);
 }
};
 };
 };
 //BA.debugLineNum = 378;BA.debugLine="End Sub";
return "";
}
public static String  _wintimer_tick() throws Exception{
String _newstr = "";
 //BA.debugLineNum = 503;BA.debugLine="Sub wintimer_tick";
 //BA.debugLineNum = 505;BA.debugLine="Select level";
switch (_level) {
case 1:
 //BA.debugLineNum = 509;BA.debugLine="If exitworm > 0 Then";
if (_exitworm>0) { 
 //BA.debugLineNum = 510;BA.debugLine="Select exitworm";
switch (_exitworm) {
case 4:
 //BA.debugLineNum = 512;BA.debugLine="Dim newstr As String = dotlist.Get(4)";
_newstr = BA.ObjectToString(mostCurrent._dotlist.Get((int) (4)));
 //BA.debugLineNum = 513;BA.debugLine="newstr = newstr.Replace(\"r\",\"e\")";
_newstr = _newstr.replace("r","e");
 //BA.debugLineNum = 514;BA.debugLine="dotlist.Set(4,newstr)";
mostCurrent._dotlist.Set((int) (4),(Object)(_newstr));
 //BA.debugLineNum = 515;BA.debugLine="points(4).worm = \"e\"";
mostCurrent._points[(int) (4)].worm = "e";
 //BA.debugLineNum = 516;BA.debugLine="points(4).head = \"e\"";
mostCurrent._points[(int) (4)].head = "e";
 break;
case 3:
 //BA.debugLineNum = 518;BA.debugLine="Dim newstr As String = dotlist.Get(5)";
_newstr = BA.ObjectToString(mostCurrent._dotlist.Get((int) (5)));
 //BA.debugLineNum = 519;BA.debugLine="newstr = newstr.Replace(\"r\",\"e\")";
_newstr = _newstr.replace("r","e");
 //BA.debugLineNum = 520;BA.debugLine="dotlist.Set(5,newstr)";
mostCurrent._dotlist.Set((int) (5),(Object)(_newstr));
 //BA.debugLineNum = 521;BA.debugLine="points(5).worm = \"e\"";
mostCurrent._points[(int) (5)].worm = "e";
 //BA.debugLineNum = 522;BA.debugLine="points(5).head = \"e\"";
mostCurrent._points[(int) (5)].head = "e";
 break;
case 2:
 //BA.debugLineNum = 524;BA.debugLine="Dim newstr As String = dotlist.Get(6)";
_newstr = BA.ObjectToString(mostCurrent._dotlist.Get((int) (6)));
 //BA.debugLineNum = 525;BA.debugLine="newstr = newstr.Replace(\"r\",\"e\")";
_newstr = _newstr.replace("r","e");
 //BA.debugLineNum = 526;BA.debugLine="dotlist.Set(6,newstr)";
mostCurrent._dotlist.Set((int) (6),(Object)(_newstr));
 //BA.debugLineNum = 527;BA.debugLine="points(6).worm = \"e\"";
mostCurrent._points[(int) (6)].worm = "e";
 //BA.debugLineNum = 528;BA.debugLine="points(6).head = \"e\"";
mostCurrent._points[(int) (6)].head = "e";
 break;
case 1:
 //BA.debugLineNum = 530;BA.debugLine="Dim newstr As String = dotlist.Get(7)";
_newstr = BA.ObjectToString(mostCurrent._dotlist.Get((int) (7)));
 //BA.debugLineNum = 531;BA.debugLine="newstr = newstr.Replace(\"r\",\"e\")";
_newstr = _newstr.replace("r","e");
 //BA.debugLineNum = 532;BA.debugLine="dotlist.Set(7,newstr)";
mostCurrent._dotlist.Set((int) (7),(Object)(_newstr));
 //BA.debugLineNum = 533;BA.debugLine="points(7).worm = \"e\"";
mostCurrent._points[(int) (7)].worm = "e";
 //BA.debugLineNum = 534;BA.debugLine="points(7).head = \"e\"";
mostCurrent._points[(int) (7)].head = "e";
 break;
}
;
 //BA.debugLineNum = 537;BA.debugLine="exitworm = exitworm - 1";
_exitworm = (int) (_exitworm-1);
 //BA.debugLineNum = 538;BA.debugLine="redrawworms";
_redrawworms();
 //BA.debugLineNum = 539;BA.debugLine="winmp.Play";
_winmp.Play();
 }else {
 //BA.debugLineNum = 541;BA.debugLine="wintimer.Enabled = False";
_wintimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 543;BA.debugLine="If Msgbox2(\"Congratulations, you solve the Puzzl";
if (anywheresoftware.b4a.keywords.Common.Msgbox2("Congratulations, you solve the Puzzle","WormPuzzle","Restart","","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 544;BA.debugLine="levelfinished = False";
_levelfinished = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 545;BA.debugLine="level = 1";
_level = (int) (1);
 //BA.debugLineNum = 546;BA.debugLine="setlevel";
_setlevel();
 //BA.debugLineNum = 547;BA.debugLine="redrawworms";
_redrawworms();
 };
 };
 break;
case 2:
 break;
}
;
 //BA.debugLineNum = 557;BA.debugLine="End Sub";
return "";
}
public static String  _wormpnl_touch(int _action,float _x,float _y) throws Exception{
int _i = 0;
String _wstr = "";
 //BA.debugLineNum = 400;BA.debugLine="Sub wormpnl_Touch (Action As Int, X As Float, Y As";
 //BA.debugLineNum = 402;BA.debugLine="Select Action";
switch (_action) {
case 0:
 //BA.debugLineNum = 405;BA.debugLine="lastx = X";
_lastx = _x;
 //BA.debugLineNum = 407;BA.debugLine="For i = 0 To 13";
{
final int step285 = 1;
final int limit285 = (int) (13);
for (_i = (int) (0); (step285 > 0 && _i <= limit285) || (step285 < 0 && _i >= limit285); _i = ((int)(0 + _i + step285))) {
 //BA.debugLineNum = 409;BA.debugLine="If X > points(i).X - 6%y AND Y > points(i).Y -";
if (_x>mostCurrent._points[_i].x-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA) && _y>mostCurrent._points[_i].y-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 410;BA.debugLine="If X < points(i).X + 6%y AND Y < points(i).Y";
if (_x<mostCurrent._points[_i].x+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA) && _y<mostCurrent._points[_i].y+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 412;BA.debugLine="If points(i).worm = \"b\" AND points(i).head =";
if ((mostCurrent._points[_i].worm).equals("b") && (mostCurrent._points[_i].head).equals("h")) { 
 //BA.debugLineNum = 413;BA.debugLine="Log(\"blue worm-head down\")";
anywheresoftware.b4a.keywords.Common.Log("blue worm-head down");
 //BA.debugLineNum = 414;BA.debugLine="Log(points(i).X & \"|\" & points(i).Y)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(mostCurrent._points[_i].x)+"|"+BA.NumberToString(mostCurrent._points[_i].y));
 //BA.debugLineNum = 415;BA.debugLine="wormnrdown = points(i).nr";
_wormnrdown = mostCurrent._points[_i].nr;
 //BA.debugLineNum = 416;BA.debugLine="redwormmove = False";
_redwormmove = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 417;BA.debugLine="bluewormmove = True";
_bluewormmove = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 418;BA.debugLine="Return";
if (true) return "";
 }else if((mostCurrent._points[_i].worm).equals("r") && (mostCurrent._points[_i].head).equals("h")) { 
 //BA.debugLineNum = 420;BA.debugLine="Log(\"Red worm-head down\")";
anywheresoftware.b4a.keywords.Common.Log("Red worm-head down");
 //BA.debugLineNum = 421;BA.debugLine="Log(points(i).X & \"|\" & points(i).Y)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(mostCurrent._points[_i].x)+"|"+BA.NumberToString(mostCurrent._points[_i].y));
 //BA.debugLineNum = 422;BA.debugLine="wormnrdown = points(i).nr";
_wormnrdown = mostCurrent._points[_i].nr;
 //BA.debugLineNum = 423;BA.debugLine="redwormmove = True";
_redwormmove = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 424;BA.debugLine="bluewormmove = False";
_bluewormmove = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 425;BA.debugLine="Return";
if (true) return "";
 };
 };
 };
 }
};
 break;
case 1:
 //BA.debugLineNum = 431;BA.debugLine="redwormmove = False";
_redwormmove = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 432;BA.debugLine="bluewormmove = False";
_bluewormmove = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 433;BA.debugLine="wormnrdown = -1";
_wormnrdown = (int) (-1);
 //BA.debugLineNum = 434;BA.debugLine="lastx = 0";
_lastx = (float) (0);
 break;
case 2:
 //BA.debugLineNum = 437;BA.debugLine="If Abs(X - lastx) >= 1%x Then 'only on a big en";
if (anywheresoftware.b4a.keywords.Common.Abs(_x-_lastx)>=anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (1),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 438;BA.debugLine="lastx = X";
_lastx = _x;
 //BA.debugLineNum = 440;BA.debugLine="If levelfinished = False Then";
if (_levelfinished==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 441;BA.debugLine="If redwormmove = True OR bluewormmove = True";
if (_redwormmove==anywheresoftware.b4a.keywords.Common.True || _bluewormmove==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 442;BA.debugLine="For i = 0 To 14";
{
final int step316 = 1;
final int limit316 = (int) (14);
for (_i = (int) (0); (step316 > 0 && _i <= limit316) || (step316 < 0 && _i >= limit316); _i = ((int)(0 + _i + step316))) {
 //BA.debugLineNum = 443;BA.debugLine="If X > points(i).X - 6%y  AND Y > points(i)";
if (_x>mostCurrent._points[_i].x-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA) && _y>mostCurrent._points[_i].y-anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 444;BA.debugLine="If X < points(i).X + 6%y AND Y < points(i)";
if (_x<mostCurrent._points[_i].x+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA) && _y<mostCurrent._points[_i].y+anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (6),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 446;BA.debugLine="If points(i).worm = \"e\" AND points(i).hea";
if ((mostCurrent._points[_i].worm).equals("e") && (mostCurrent._points[_i].head).equals("e")) { 
 //BA.debugLineNum = 447;BA.debugLine="If points(i).nr - wormnrdown = 1 OR worm";
if (mostCurrent._points[_i].nr-_wormnrdown==1 || _wormnrdown-mostCurrent._points[_i].nr==1) { 
 //BA.debugLineNum = 449;BA.debugLine="Dim wstr As String";
_wstr = "";
 //BA.debugLineNum = 450;BA.debugLine="If redwormmove = True Then wstr = \"r\"";
if (_redwormmove==anywheresoftware.b4a.keywords.Common.True) { 
_wstr = "r";};
 //BA.debugLineNum = 451;BA.debugLine="If bluewormmove = True Then wstr = \"b\"";
if (_bluewormmove==anywheresoftware.b4a.keywords.Common.True) { 
_wstr = "b";};
 //BA.debugLineNum = 453;BA.debugLine="updatepoints(points(i).nr,wstr,wormnrd";
_updatepoints(mostCurrent._points[_i].nr,_wstr,_wormnrdown);
 //BA.debugLineNum = 454;BA.debugLine="wormnrdown = points(i).nr";
_wormnrdown = mostCurrent._points[_i].nr;
 //BA.debugLineNum = 455;BA.debugLine="redrawworms";
_redrawworms();
 //BA.debugLineNum = 456;BA.debugLine="If movemp.IsPlaying = False Then";
if (_movemp.IsPlaying()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 457;BA.debugLine="movemp.Position = 0";
_movemp.setPosition((int) (0));
 //BA.debugLineNum = 458;BA.debugLine="movemp.play";
_movemp.Play();
 };
 //BA.debugLineNum = 460;BA.debugLine="Return";
if (true) return "";
 };
 }else {
 //BA.debugLineNum = 467;BA.debugLine="If redwormmove = True Then";
if (_redwormmove==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 468;BA.debugLine="If points(i).worm = \"b\" AND points(i).h";
if ((mostCurrent._points[_i].worm).equals("b") && (mostCurrent._points[_i].head).equals("h")) { 
 //BA.debugLineNum = 469;BA.debugLine="If Abs(points(i).nr - wormnrdown) = 1";
if (anywheresoftware.b4a.keywords.Common.Abs(mostCurrent._points[_i].nr-_wormnrdown)==1) { 
 //BA.debugLineNum = 470;BA.debugLine="If collisionmp.IsPlaying = False Then";
if (_collisionmp.IsPlaying()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 471;BA.debugLine="collisionmp.Position = 0";
_collisionmp.setPosition((int) (0));
 //BA.debugLineNum = 472;BA.debugLine="collisionmp.play";
_collisionmp.Play();
 };
 //BA.debugLineNum = 474;BA.debugLine="Return";
if (true) return "";
 };
 }else if((mostCurrent._points[_i].worm).equals("f")) { 
 //BA.debugLineNum = 477;BA.debugLine="checkifsharpturn(points(i).nr,wormnrdo";
_checkifsharpturn(mostCurrent._points[_i].nr,_wormnrdown);
 //BA.debugLineNum = 478;BA.debugLine="Return";
if (true) return "";
 };
 }else if(_bluewormmove==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 481;BA.debugLine="If points(i).worm = \"r\" AND points(i).h";
if ((mostCurrent._points[_i].worm).equals("r") && (mostCurrent._points[_i].head).equals("h")) { 
 //BA.debugLineNum = 482;BA.debugLine="If Abs(points(i).nr - wormnrdown) = 1";
if (anywheresoftware.b4a.keywords.Common.Abs(mostCurrent._points[_i].nr-_wormnrdown)==1) { 
 //BA.debugLineNum = 483;BA.debugLine="If collisionmp.IsPlaying = False Then";
if (_collisionmp.IsPlaying()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 484;BA.debugLine="collisionmp.Position = 0";
_collisionmp.setPosition((int) (0));
 //BA.debugLineNum = 485;BA.debugLine="collisionmp.play";
_collisionmp.Play();
 };
 //BA.debugLineNum = 487;BA.debugLine="Return";
if (true) return "";
 };
 };
 };
 };
 };
 };
 }
};
 };
 };
 };
 break;
}
;
 //BA.debugLineNum = 501;BA.debugLine="End Sub";
return "";
}
}
